const pg = require('pg');
const multer = require('multer');
const fs = require('fs');
const moment = require('moment');
//process.env.TZ = "Asia/Calcutta";


function isNull(item){
    if(item){
        return item;
    }else{
        return "";
    }
}


// const pool = new pg.Pool({
//     user: 'postgres',
//     host: 'database-1.cvy40iky4ww1.ap-south-1.rds.amazonaws.com',
//     database: 'postgres',
//     password: 'LoGiCmysql123',
//     port: 5432
// });



const pool = new pg.Pool({
    user: 'ojpasoftware_NFT_user',
    host: '109.123.236.127',
    database: 'ojpasoftware_fyrochain',
    password: 'LoGiCmysql123',
    port: 5432
});



module.exports = {



    latest_transection_list: (request, response) => {
        //const { sport_category_id } = request.body

        //console.log('SELECT * FROM tbl_transection order by tbl_transection_id DESC limit 10');

        pool.query('SELECT * FROM tbl_transection order by tbl_transection_id DESC limit 10',(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
               
                        var res = result.rows;
                        var data = [];
                        res.forEach(function (table) {

                            if(table.transection_status=='true')
                            {
                                var status_show = 'Success';
                            }else{
                                var status_show = 'Fail';
                            }
        
                            let cat = {
                                tbl_transection_id: table.tbl_transection_id,
                                hash: table.hash,
                                blockhash: table.blockhash,
                                blocknumber: table.blocknumber,
                                from_address: table.from_address,
                                to_address: table.to_address,
                                gas: table.gas,
                                value: table.value,
                                status_show: status_show,
                                created_date: moment(table.created_date).utcOffset("+05:30").format('DD MMM YYYY LT')
                            };
                            data.push(cat);
        
                        });
                        
                    response.status(201).json({ status: true, message: 'Latest Transection List Data', data: data })
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', data: [] })        
            }

        })
    
    },

    all_transection_list: (request, response) => {
        //const { sport_category_id } = request.body

        pool.query('SELECT * FROM tbl_transection order by tbl_transection_id DESC limit 200',(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
               
                        var res = result.rows;
                        var data = [];
                        res.forEach(function (table) {

                            if(table.transection_status=='true')
                            {
                                var status_show = 'Success';
                            }else{
                                var status_show = 'Fail';
                            }
        
                            let cat = {
                                tbl_transection_id: table.tbl_transection_id,
                                hash: table.hash,
                                blockhash: table.blockhash,
                                blocknumber: table.blocknumber,
                                from_address: table.from_address,
                                to_address: table.to_address,
                                gas: table.gas,
                                value: table.value,
                                status_show: status_show,
                                created_date: moment(table.created_date).utcOffset("+05:30").format('DD MMM YYYY LT')
                            };
                            data.push(cat);
        
                        });
                        
                    response.status(201).json({ status: true, message: 'Latest Transection List Data', data: data })
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', data: [] })        
            }

        })
    
    },



    user_waise_transection_list: (request, response) => {
        const { address } = request.params


        pool.query(`SELECT * FROM tbl_transection WHERE LOWER(from_address) = LOWER('${address}') OR LOWER(to_address) = LOWER('${address}') ORDER BY tbl_transection_id DESC LIMIT 500`,(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
               
                        var res = result.rows;
                        var data = [];
                        res.forEach(function (table) {

                            if(table.transection_status=='true')
                            {
                                var status_show = 'Success';
                            }else{
                                var status_show = 'Fail';
                            }
        
                            let cat = {
                                tbl_transection_id: table.tbl_transection_id,
                                hash: table.hash,
                                type: table.type,
                                blockhash: table.blockhash,
                                blocknumber: table.blocknumber,
                                from_address: table.from_address,
                                to_address: table.to_address,
                                gas: table.gas,
                                value: table.value,
                                status_show: status_show,
                                created_date: moment(table.created_date).utcOffset("+05:30").format('DD MMM YYYY LT')
                            };
                            data.push(cat);
        
                        });
                        
                    response.status(201).json({ status: true, message: 'User wise Transection List Data', data: data })
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', data: [] })        
            }

        })
    
    },



    top_10_transection_account_list: (request, response) => {
        const { address } = request.params

        pool.query(`SELECT from_address,COUNT(*) AS transaction_count,SUM(value) AS total_amount FROM tbl_transection GROUP BY from_address ORDER BY transaction_count DESC
        LIMIT 10;`,(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
               
                        var res = result.rows;
                        var data = [];
                        res.forEach(function (table) {
        
                            let cat = {
                                from_address: table.from_address,
                                transaction_count: table.transaction_count,
                                total_amount: table.total_amount
                            };
                            data.push(cat);
        
                        });
                        
                    response.status(201).json({ status: true, message: 'top_10_transection_account_list Data', data: data })
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', data: [] })        
            }

        })
    
    },



    top_10_transection_gas_list: (request, response) => {
        const { address } = request.params

        pool.query(`SELECT from_address,COUNT(*) AS transaction_count,SUM(CAST(gas AS numeric)) AS total_gas FROM tbl_transection 
        GROUP BY from_address ORDER BY transaction_count DESC LIMIT 10`,(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
               
                        var res = result.rows;
                        var data = [];
                        res.forEach(function (table) {
        
                            let cat = {
                                from_address: table.from_address,
                                transaction_count: table.transaction_count,
                                total_gas: table.total_gas
                            };
                            data.push(cat);
        
                        });
                        
                    response.status(201).json({ status: true, message: 'top_10_transection_account_list Data', data: data })
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', data: [] })        
            }

        })
    
    },


    surrent_supply_api: (request, response) => {
        //const { sport_category_id } = request.body

        pool.query('SELECT current_amount FROM tbl_current_supply where status = 1',(error, result) => {

            if (error) {
                return response.status(403).json({ status: false, message: error })
            }
            var count = result.rowCount;
            if (count > 0) {
                        
                    response.status(201).json({ status: true, message: 'Current supply', current_amount: result.rows[0].current_amount})
            } else {
                     response.status(201).json({ status: true, message: 'No Data Found', current_amount: 0 })        
            }

        })
    
    },


};