const express = require('express');
const bodyParser = require('body-parser');
const Web3 = require('web3');

const app = express();
const port = 3000; // Define your port

app.use(bodyParser.json()); // For parsing application/json

const web3 = new Web3('https://rpc.siftoscan.com/'); // Replace with your RPC URL
const senderAddress = '0x00a6ed2E858b841DBf44A57f910C94041565880B'; // Replace with your sender address
const privateKey = '0e906d926cdb6b67369e4cef0aab0d37ac9a59b9db3c0fa0baaf1ee1485ef648'; // Replace with your private key

app.post('/send-coins', async (req, res) => {
    const { recipients } = req.body;

    try {
        // Get the current nonce just before sending transactions
        let nonce = await web3.eth.getTransactionCount(senderAddress);

        // Create an array to store all transaction promises
        const transactionPromises = recipients.map((recipient, index) => {
            const txObject = {
                from: senderAddress,
                to: recipient.address,
                value: recipient.amount,
                gas: web3.utils.toHex(41000), // Gas limit as per your configuration
                gasPrice: web3.utils.toHex(web3.utils.toWei('20', 'gwei')), // Gas price (e.g., 20 Gwei)
                nonce: web3.utils.toHex(nonce + index), // Increment the nonce for each transaction
                chainId: 506 // Chain ID as per your configuration
            };

            // Sign the transaction
            return web3.eth.accounts.signTransaction(txObject, privateKey)
                .then(signedTx => web3.eth.sendSignedTransaction(signedTx.rawTransaction));
        });

        // Wait for all transactions to be sent
        const receipts = await Promise.all(transactionPromises);

        // Return the transaction hashes
        res.json({
            status: 'success',
            transactionHashes: receipts.map(receipt => receipt.transactionHash),
            message: 'Transactions sent successfully!',
        });

    } catch (error) {
        res.status(500).json({
            status: 'error',
            message: 'Transaction failed!',
            error: error.message,
        });
    }
});

app.listen(port, () => {
    console.log(`Server is running on port ${port}`);
});
