const express = require('express');
const axios = require('axios');
const { Client } = require('pg');
const Web3 = require('web3');

const app = express();
const port = 3800;


const dbConfig = {
    user: 'postgres',
    host: '101.53.149.203',
    database: 'shiftochain',
    password: 'LoGiCmysql123',
    port: '5432',
  };
// Create a PostgreSQL client
const pool = new Client(dbConfig);

// Connect to PostgreSQL
pool.connect()
  .then(() => console.log('Connected to PostgreSQL'))
  .catch(err => console.error('Error connecting to PostgreSQL', err));

// RPC URL for your blockchain
const web3 = new Web3('https://rpc.siftoscan.com'); // Replace with your Geth RPC URL

const handleLatestTransactions = async () => {

    console.log("handleLatestTransactions");
    try {
        // Get the latest block number
        const latestBlockNumber = await web3.eth.getBlockNumber();

        // Initialize an array to store transactions
        let transactions = [];

        // Loop through the last 10 blocks
        for (let i = latestBlockNumber; i > Math.max(0, latestBlockNumber - 10); i--) {
            // Get the block
            const block = await web3.eth.getBlock(i);

            // Loop through transactions in the block
            for (const txHash of block.transactions) {
                // Check if transaction hash already exists in the database
                
                    // Get transaction details
                    const tx = await web3.eth.getTransaction(txHash);
                    //console.log("tx",tx);
                    const receipt = await web3.eth.getTransactionReceipt(txHash);
                    const status = receipt ? receipt.status : 'Pending';
                   // console.log("receipt",receipt);

                    var amount = (tx.value/1000000000000000000)

                    // Insert transaction into the database
                    if(tx.from != '0x4F4EDD1d27dAe9e746c264b64D429DB410966651' && 
                        tx.from != '0xaA718cFe1B94910Ea030491397F69Aa2eebf0DA4' && 
                        tx.from != '0xa042CD5D4Ba25CA3F8657Ace554D646F711fd46F' && 
                        tx.from != '0xF0880920C5FAf7fB6E83769b760411D39770eE80' && 
                        tx.from != '0x245e7e297a84564D671324B69df1F009527991D3' && 
                        tx.from != '0x86d153229544991dbC17Db97e0a27a05602BA537' && 
                        tx.from != '0xd78A960a5dfbb44055F7B3406f19e445801BbbF8' && 
                        tx.from != '0x4A0e7ab552707e084320A33C7D611cA08f329696' && 
                        tx.from != '0xa57525fE58267845884cc36a6D312F91Ceb7E012' && 
                        tx.from != '0x10245f281C35ecd3aA5F8BF9e87e62490C5bb2D8' && 
                        tx.from != '0x1c4c310e508A3958b80338986F90726218a758ad' && 
                        tx.from != '0xED32Ff260E60d401D8c453Ff9b9A6eedd3087f3A' && 
                        tx.from != '0xE7aBcb34c17C8bd049594dCcc9c45ae07b449a5b' && 
                        tx.from != '0xeFfD0797B9d6171245417ba932CFA12a0D464547') {
                        
                            
                        await pool.query(`INSERT INTO tbl_transection (hash, blockhash, blocknumber, from_address, gas, gasprice, input, nonce, to_address, transactionindex, value, type, chainid, v, r, s, transection_status) SELECT '${txHash}', '${tx.blockHash}', '${tx.blockNumber}', '${tx.from}', '${tx.gas}', '${tx.gasPrice}', '${tx.input}', '${tx.nonce}', '${tx.to}', '${tx.transactionIndex}', '${amount}', '${tx.type}', '${tx.chainId}', '${tx.v}', '${tx.r}', '${tx.s}', '${status}' WHERE NOT EXISTS ( SELECT 1 FROM tbl_transection WHERE hash = '${txHash}' );
                         UPDATE tbl_current_supply SET current_amount = current_amount + '${amount}'`);


                        }

                    // Add transaction details to the array
                    transactions.push(tx);
                //}
            }
        }

        console.log('Latest transactions processed.');
    } catch (error) {
        console.error('Error fetching latest transactions:', error.message);
    }
};

// Call the handler initially
handleLatestTransactions();

// Call the handler every 5 seconds
setInterval(handleLatestTransactions, 5000);

// Start the Express server
//const port = process.env.PORT || 5001;
app.listen(port, () => {
    console.log(`Server is running on port ${port}`);
});
