const express = require('express');
const { Client } = require('pg');
const Web3 = require('web3');

const app = express();
const port = 3808;

// PostgreSQL database connection configuration
const dbConfig = {
  user: 'postgres',
  host: 'database-1.cvy40iky4ww1.ap-south-1.rds.amazonaws.com',
  database: 'postgres',
  password: 'LoGiCmysql123',
  port: '5432',
};

// Create a PostgreSQL client
const pool = new Client(dbConfig);

// Connect to PostgreSQL
pool.connect()
  .then(() => console.log('Connected to PostgreSQL'))
  .catch(err => console.error('Error connecting to PostgreSQL', err));

// RPC URL for your blockchain
const web3 = new Web3('https://rpc.siftoscan.com'); // Replace with your Geth RPC URL

const getBlockByDate = async (targetDate) => {
    let block = await web3.eth.getBlock('latest');
    let blockDate = new Date(block.timestamp * 1000);

    while (blockDate > targetDate) {
        block = await web3.eth.getBlock(block.number - 1);
        blockDate = new Date(block.timestamp * 1000);
    }

    return block;
};

const handleTransactionsByDate = async (targetDate) => {
    console.log("handleTransactionsByDate");
    try {
        const startDate = new Date(targetDate);
        startDate.setUTCHours(0, 0, 0, 0);
        const endDate = new Date(targetDate);
        endDate.setUTCHours(23, 59, 59, 999);

        let block = await getBlockByDate(endDate);
        let transactions = [];



        while (new Date(block.timestamp * 1000) >= startDate && new Date(block.timestamp * 1000) <= endDate) {

            console.log("block.timestamp",block.timestamp);

            // for (const txHash of block.transactions) {
            //     const tx = await web3.eth.getTransaction(txHash);
            //     const receipt = await web3.eth.getTransactionReceipt(txHash);
            //     const status = receipt ? receipt.status : 'Pending';
            //     const amount = (tx.value / 1000000000000000000);

            //     if (!['0x4F4EDD1d27dAe9e746c264b64D429DB410966651', '0xaA718cFe1B94910Ea030491397F69Aa2eebf0DA4', '0xa042CD5D4Ba25CA3F8657Ace554D646F711fd46F', '0xF0880920C5FAf7fB6E83769b760411D39770eE80', '0x245e7e297a84564D671324B69df1F009527991D3', '0x86d153229544991dbC17Db97e0a27a05602BA537', '0xd78A960a5dfbb44055F7B3406f19e445801BbbF8', '0x4A0e7ab552707e084320A33C7D611cA08f329696', '0xa57525fE58267845884cc36a6D312F91Ceb7E012', '0x10245f281C35ecd3aA5F8BF9e87e62490C5bb2D8', '0x1c4c310e508A3958b80338986F90726218a758ad', '0xED32Ff260E60d401D8c453Ff9b9A6eedd3087f3A', '0xE7aBcb34c17C8bd049594dCcc9c45ae07b449a5b', '0xeFfD0797B9d6171245417ba932CFA12a0D464547'].includes(tx.from)) {
            //         await pool.query(`INSERT INTO tbl_transection (hash, blockhash, blocknumber, from_address, gas, gasprice, input, nonce, to_address, transactionindex, value, type, chainid, v, r, s, transection_status) SELECT '${txHash}', '${tx.blockHash}', '${tx.blockNumber}', '${tx.from}', '${tx.gas}', '${tx.gasPrice}', '${tx.input}', '${tx.nonce}', '${tx.to}', '${tx.transactionIndex}', '${amount}', '${tx.type}', '${tx.chainId}', '${tx.v}', '${tx.r}', '${tx.s}', '${status}' WHERE NOT EXISTS ( SELECT 1 FROM tbl_transection WHERE hash = '${txHash}' );
            //          UPDATE tbl_current_supply SET current_amount = current_amount + '${amount}'`);
            //     }

            //     transactions.push(tx);
            // }

            block = await web3.eth.getBlock(block.number - 1);
        }

        console.log('Transactions from specified date processed.');
    } catch (error) {
        console.error('Error fetching transactions:', error.message);
    }
};

// Specify the date for which you want to fetch transactions
const targetDate = '2024-06-28';
handleTransactionsByDate(targetDate);

// Start the Express server
app.listen(port, () => {
    console.log(`Server is running on port ${port}`);
});
