const PORT = process.env.PORT || 4900;
var http = require('http');
var ethers = require('ethers');
var Wallet = ethers.Wallet;
var utils = ethers.utils;
var providers = ethers.providers;
var url = require('url');
var express = require('express');
const Tx = require('ethereumjs-tx');
var Common = require('ethereumjs-common');
var sql = require("mssql");
var bodyParser = require("body-parser");
 //Initializing connection string
 var dbConfig = {
    user:  "",
    password: "",
    server: "",
    database: "", 
    synchronize: true,
    trustServerCertificate: true,
};

var data={};
var _ = require("underscore");
var app = express();
app.use(bodyParser.json());
var ABI=[{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"receiver","type":"address"},{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":false,"internalType":"uint8","name":"matrix","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"level","type":"uint8"}],"name":"MissedEthReceive","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"user","type":"address"},{"indexed":true,"internalType":"address","name":"referrer","type":"address"},{"indexed":false,"internalType":"uint8","name":"matrix","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"level","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"place","type":"uint8"}],"name":"NewUserPlace","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"user","type":"address"},{"indexed":true,"internalType":"address","name":"referrer","type":"address"},{"indexed":true,"internalType":"uint256","name":"userId","type":"uint256"},{"indexed":false,"internalType":"uint256","name":"referrerId","type":"uint256"}],"name":"Registration","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"user","type":"address"},{"indexed":true,"internalType":"address","name":"currentReferrer","type":"address"},{"indexed":true,"internalType":"address","name":"caller","type":"address"},{"indexed":false,"internalType":"uint8","name":"matrix","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"level","type":"uint8"}],"name":"Reinvest","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"from","type":"address"},{"indexed":true,"internalType":"address","name":"receiver","type":"address"},{"indexed":false,"internalType":"uint8","name":"matrix","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"level","type":"uint8"}],"name":"SentExtraEthDividends","type":"event"},{"anonymous":false,"inputs":[{"indexed":true,"internalType":"address","name":"user","type":"address"},{"indexed":true,"internalType":"address","name":"referrer","type":"address"},{"indexed":false,"internalType":"uint8","name":"matrix","type":"uint8"},{"indexed":false,"internalType":"uint8","name":"level","type":"uint8"}],"name":"Upgrade","type":"event"},{"stateMutability":"nonpayable","type":"fallback"},{"inputs":[],"name":"BASIC_PRICE","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"LAST_LEVEL","outputs":[{"internalType":"uint8","name":"","type":"uint8"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"","type":"address"}],"name":"balances","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint8","name":"matrix","type":"uint8"},{"internalType":"uint8","name":"level","type":"uint8"}],"name":"buyNewLevel","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"address","name":"userAddress","type":"address"},{"internalType":"uint8","name":"matrix","type":"uint8"},{"internalType":"uint8","name":"level","type":"uint8"}],"name":"buyNewLevelFor","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[],"name":"changeLock","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[],"name":"contractOwner","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"depositToken","outputs":[{"internalType":"contract IERC20","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"userAddress","type":"address"},{"internalType":"uint8","name":"level","type":"uint8"}],"name":"findFreeXReferrer","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"id1","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint256","name":"","type":"uint256"}],"name":"idToAddress","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"impl","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"_ownerAddress","type":"address"},{"internalType":"address","name":"_multisig","type":"address"},{"internalType":"contract IERC20","name":"_depositTokenAddress","type":"address"}],"name":"init","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"address","name":"user","type":"address"}],"name":"isUserExists","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"lastUserId","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"uint8","name":"","type":"uint8"}],"name":"levelPrice","outputs":[{"internalType":"uint256","name":"","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"locked","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[],"name":"multisig","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"referrerAddress","type":"address"}],"name":"registrationExt","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"address","name":"userAddress","type":"address"},{"internalType":"address","name":"referrerAddress","type":"address"}],"name":"registrationFor","outputs":[],"stateMutability":"nonpayable","type":"function"},{"inputs":[{"internalType":"uint256","name":"","type":"uint256"}],"name":"userIds","outputs":[{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"","type":"address"}],"name":"users","outputs":[{"internalType":"uint256","name":"id","type":"uint256"},{"internalType":"address","name":"referrer","type":"address"},{"internalType":"uint256","name":"partnersCount","type":"uint256"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"userAddress","type":"address"},{"internalType":"uint8","name":"level","type":"uint8"}],"name":"usersActiveXLevels","outputs":[{"internalType":"bool","name":"","type":"bool"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"userAddress","type":"address"},{"internalType":"uint8","name":"level","type":"uint8"}],"name":"usersXMatrix","outputs":[{"internalType":"address","name":"","type":"address"},{"internalType":"address[]","name":"","type":"address[]"},{"internalType":"address[]","name":"","type":"address[]"},{"internalType":"bool","name":"","type":"bool"},{"internalType":"address","name":"","type":"address"}],"stateMutability":"view","type":"function"},{"inputs":[{"internalType":"address","name":"tokenAddress","type":"address"}],"name":"withdrawLostTokens","outputs":[],"stateMutability":"nonpayable","type":"function"}];
var ABIToken=[{ "inputs": [], "payable": false, "stateMutability": "nonpayable", "type": "constructor" }, { "anonymous": false, "inputs": [{ "indexed": true, "internalType": "address", "name": "owner", "type": "address" }, { "indexed": true, "internalType": "address", "name": "spender", "type": "address" }, { "indexed": false, "internalType": "uint256", "name": "value", "type": "uint256" }], "name": "Approval", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "internalType": "address", "name": "previousOwner", "type": "address" }, { "indexed": true, "internalType": "address", "name": "newOwner", "type": "address" }], "name": "OwnershipTransferred", "type": "event" }, { "anonymous": false, "inputs": [{ "indexed": true, "internalType": "address", "name": "from", "type": "address" }, { "indexed": true, "internalType": "address", "name": "to", "type": "address" }, { "indexed": false, "internalType": "uint256", "name": "value", "type": "uint256" }], "name": "Transfer", "type": "event" }, { "constant": true, "inputs": [], "name": "_decimals", "outputs": [{ "internalType": "uint8", "name": "", "type": "uint8" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "_name", "outputs": [{ "internalType": "string", "name": "", "type": "string" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "_symbol", "outputs": [{ "internalType": "string", "name": "", "type": "string" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [{ "internalType": "address", "name": "owner", "type": "address" }, { "internalType": "address", "name": "spender", "type": "address" }], "name": "allowance", "outputs": [{ "internalType": "uint256", "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "spender", "type": "address" }, { "internalType": "uint256", "name": "amount", "type": "uint256" }], "name": "approve", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [{ "internalType": "address", "name": "account", "type": "address" }], "name": "balanceOf", "outputs": [{ "internalType": "uint256", "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "uint256", "name": "amount", "type": "uint256" }], "name": "burn", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "decimals", "outputs": [{ "internalType": "uint8", "name": "", "type": "uint8" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "spender", "type": "address" }, { "internalType": "uint256", "name": "subtractedValue", "type": "uint256" }], "name": "decreaseAllowance", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "getOwner", "outputs": [{ "internalType": "address", "name": "", "type": "address" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "spender", "type": "address" }, { "internalType": "uint256", "name": "addedValue", "type": "uint256" }], "name": "increaseAllowance", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "uint256", "name": "amount", "type": "uint256" }], "name": "mint", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "name", "outputs": [{ "internalType": "string", "name": "", "type": "string" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "owner", "outputs": [{ "internalType": "address", "name": "", "type": "address" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [], "name": "renounceOwnership", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": true, "inputs": [], "name": "symbol", "outputs": [{ "internalType": "string", "name": "", "type": "string" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": true, "inputs": [], "name": "totalSupply", "outputs": [{ "internalType": "uint256", "name": "", "type": "uint256" }], "payable": false, "stateMutability": "view", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "recipient", "type": "address" }, { "internalType": "uint256", "name": "amount", "type": "uint256" }], "name": "transfer", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "sender", "type": "address" }, { "internalType": "address", "name": "recipient", "type": "address" }, { "internalType": "uint256", "name": "amount", "type": "uint256" }], "name": "transferFrom", "outputs": [{ "internalType": "bool", "name": "", "type": "bool" }], "payable": false, "stateMutability": "nonpayable", "type": "function" }, { "constant": false, "inputs": [{ "internalType": "address", "name": "newOwner", "type": "address" }], "name": "transferOwnership", "outputs": [], "payable": false, "stateMutability": "nonpayable", "type": "function" }];
const Web3 = require('web3');

//const web3 = new Web3('https://bsc-dataseed1.binance.org:443');
const web3 = new Web3('https://rpc.siftoscan.com');

var Contract = require('web3-eth-contract');
const { log } = require('console');

// set provider for all later instances to use
//Contract.setProvider('https://bsc-dataseed1.binance.org:443');
Contract.setProvider('https://rpc.siftoscan.com');

app.use((req, res, next) => {
 //console.log('%O', req);
 next();
});

app.get('/', function (req, res) {

	data={};

	

	var queryData = url.parse(req.url, true).query;

	console.log("queryData.AmountT",queryData.AmountT);
	if(queryData.PKEYT !=null && queryData.PKEYT != '' && queryData.ContractAddressT !=null && queryData.ContractAddressT != '' && queryData.ToAddressT !=null && queryData.ToAddressT != ''&& queryData.AmountT !=null && queryData.AmountT != '' ){


		
		
		// try{
		// 	//res.send('0xC615Cd5AB54Cea1A9aDA3fFbD236128500b8b265').toLowerCase());
			
		// 	sql.connect(dbConfig, function (err) {  
		// 		if (err) console.log("err",err); 
		// 		var request = new sql.Request();  
		// 		const {PKEYT,ContractAddressT} = req.body  
		// 		request.query(`sp_Payout_Wallet '${queryData.ContractAddressT}','${queryData.PKEYT}'`, function (err, recordset) {
		// 			if (err) {console.log(err)  }
		// 			else{
		// 				console.log('Wallet address created');
		// 				//res.status(201).json({ status: true, message: 'Wallet address created', data: recordset.recordset[0]}) }
		// 	}
		// }); 
		// 	}); 
 
		// 	var account = web3.eth.accounts.privateKeyToAccount(queryData.PKEYT);	
		
		// 	const myContract = new web3.eth.Contract(ABIToken, queryData.ContractAddressT);
		// 	var privateKey = Buffer.from(account.privateKey.substring(2), 'hex');
			
			
		// 	web3.eth.getTransactionCount(account.address, function(err, result) {
				
		// 		var txObject = {};
		// 		txObject.nonce = web3.utils.toHex(result);
		// 		txObject.gasLimit = web3.utils.toHex(90000);
		// 		txObject.gasPrice = web3.utils.toHex(10000000000),
		// 		txObject.to = queryData.ContractAddressT;
		// 		txObject.from = account.address;
		// 		txObject.value = '0x';

		// 		// Calling transfer function of contract and encode it in AB format
		// 		txObject.data = myContract.methods.transfer(queryData.ToAddressT, queryData.AmountT).encodeABI();
				
		// 		//console.log("TX",Tx);
		// 		//Sign transaction before sending
		// 		var tx = new Tx(txObject);
		// 		tx.sign(privateKey);
				
		// 		var serializedTx = tx.serialize();
		// 		web3.eth.sendSignedTransaction('0x' + serializedTx.toString('hex'))
		// 		.on('error', function(error){
		// 			console.log("-> error")
		// 			data.status = "failed";
		//         	data.Transactions=error.message;
		// 			res.send(JSON.stringify(data));
		// 		})
		// 		.on('transactionHash', function(transactionHash){
		// 			console.log("-> transactionHash")
		// 			data.status = "success";
		//         	data.Transactions=transactionHash;
		// 			res.send(JSON.stringify(data));
		// 		})
		// 		.on('receipt', function(receipt){
		// 			console.log("-> receipt")
		// 			data.status = "success";
		//         	data.Transactions=transactionHash;
		// 			res.send(JSON.stringify(data));
		// 		})
		// 		.on('confirmation', function(confirmationNumber, receipt){
		// 			data.status = "success";
		//         	data.Transactions=transactionHash;
		// 			res.send(JSON.stringify(data));
		// 		})
		// 	})
		// 	.catch(function(fallback) {
		// 		   res.type('application/json');
		// 			data.status = "failed";
		// 			data.Transactions=fallback;//.hash;
		// 			res.send(JSON.stringify(data));
		// 	});
		// }
		// catch(err)
		// {
		// 	res.type('application/json');
		// 	data.status = "failed";
		// 	data.Transactions="from outer"+err;
		//     res.send(JSON.stringify(data));
		// }
    }
	else if(queryData.PKEYT !=null && queryData.PKEYT != '' && queryData.ToAddressT !=null && queryData.ToAddressT != ''&& queryData.AmountT !=null && queryData.AmountT != '' ){
		try{
			console.log("transfer_api");
			var account = web3.eth.accounts.privateKeyToAccount(queryData.PKEYT);
			var privateKey = Buffer.from(account.privateKey.substring(2), 'hex');
			web3.eth.getTransactionCount(account.address, function(err, result) {
				
				var txObject = {};
				txObject.nonce = web3.utils.toHex(result);
				txObject.gasLimit = web3.utils.toHex(41000);
				txObject.gasPrice = web3.utils.toHex(20 * 1e9),
				txObject.to = queryData.ToAddressT;
				txObject.from = account.address;
				txObject.value = web3.utils.numberToHex(web3.utils.toWei(queryData.AmountT, 'ether'));
				txObject.chainId = 506

				// Calling transfer function of contract and encode it in AB format
				//txObject.data = myContract.methods.transfer(queryData.ToAddressT, queryData.AmountT).encodeABI();
				var tx = new Tx(txObject);
				//console.log(tx);
				tx.sign(privateKey);
				
				var serializedTx = tx.serialize();
				web3.eth.sendSignedTransaction('0x' + serializedTx.toString('hex'))
				.on('error', function(error){
					console.log("errorerror",error)
					res.send(error);
				})
// 			var account = web3.eth.accounts.privateKeyToAccount(queryData.PKEYT);
// var privateKey = Buffer.from(account.privateKey.substring(2), 'hex');
// web3.eth.getTransactionCount(account.address, function(err, result) {
//     var txObject = {};
//     txObject.nonce = web3.utils.toHex(result);
//     txObject.gasLimit = web3.utils.toHex(41000);
//     txObject.gasPrice = web3.utils.toHex(20 * 1e9),
//     txObject.to = queryData.ToAddressT;
//     txObject.from = account.address;
//     txObject.value = web3.utils.numberToHex(web3.utils.toWei(queryData.AmountT, 'ether'));
//     txObject.chainId = 505; // Set the chain ID to 505

//     var tx = new Tx(txObject);
//     tx.sign(privateKey);
    
//     var serializedTx = tx.serialize();
//     web3.eth.sendSignedTransaction('0x' + serializedTx.toString('hex'))
//     .on('error', function(error){
//         console.log("errorerror",error)
//         res.send(error);
//     })
				
				.on('transactionHash', function(transactionHash){
					
					console.log("-> transactionHash")
					const responseObject = {
						Transactions: transactionHash
					};
					res.send(JSON.stringify(responseObject));
				})
				// .on('receipt', function(receipt){
				// 	console.log("-> receipt")
				// 	res.send(JSON.stringify(receipt.contractAddress));
				// 	//console.log(receipt.contractAddress) // contains the new contract address
				// })
				// .on('confirmation', function(confirmationNumber, receipt){
				// 	res.send(JSON.stringify(confirmationNumber));
				// 	console.log("-> confirmation " + confirmationNumber)
				// }) 
				
			})
			.catch(function(fallback) {
				   res.type('application/json');
					data.status = "failed";
					data.Transactions="";//.hash;
					res.send(JSON.stringify(data));
			});
		}
		catch(err)
		{
			res.type('application/json');
			data.status = "failed";
			data.Transactions="from outer"+err;
		    res.send(JSON.stringify(data));
		}
	}
	else if(queryData.eventAddress !=null && queryData.eventAddress !='' && queryData.eventName !=null && queryData.eventName !='' && queryData.fromBlock !=null && queryData.fromBlock !='')
	 {
		var contract = new Contract(ABI, queryData.eventAddress);
		contract.getPastEvents(queryData.eventName,
		{
			fromBlock: queryData.fromBlock,
			toBlock: 'latest'
		},
		function(error, event){ 
			console.log(event);res.send(JSON.stringify(event));
		})
		.then(function(events){
			console.log(events);
			res.send(JSON.stringify(events));			// same results as the optional callback above
		});;
		 
	 }
	 else if(queryData.eventAddress !=null && queryData.eventAddress !='' && queryData.useraddress !='' && queryData.useraddress !=null && queryData.level !='' && queryData.level !=null )
	 {
		var contract = new Contract(ABI, queryData.eventAddress);
		contract.methods.usersXMatrix(queryData.useraddress,queryData.level).call({from: queryData.eventAddress})
		.then(function(result){
			
			res.send(JSON.stringify(result));			// same results as the optional callback above
		});;
		 
	 }
	 else if(queryData.eventAddress !=null && queryData.eventAddress !='' && queryData.txn !='' && queryData.txn !=null && queryData.level !='' && queryData.level !=null )
	 {
		res.type('application/json');		
		response = {"UserAddress":"","UserRegId":"","UserParentAddress":"", "Reinvest" : [], "Transfers" : [], "Parents" : []};
		web3.eth.getTransactionReceipt(queryData.txn)
		.then(function(txnresult){			
			//res.send(JSON.stringify(txnresult));	
			//var contract = new Contract(ABI, queryData.eventAddress);			
			//"0x309bb360e8b69c23937ccc5fb01f9aeeead1c95a99604e175113ff82f2b1723a" = registration
			//"0xa00c953eff38ec1b71e7fe060b2ab8df0bbe5354319fbdde4fbdafd6324386a6" = reinvest
			//"0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef" = transfer
			if(txnresult.status==true)				
			    data.status = "succeed";
		    else
		        data.status = "failed";
			txnresult.logs.forEach(function(item) {
				
				// if(item.topics[0] == "0xa00c953eff38ec1b71e7fe060b2ab8df0bbe5354319fbdde4fbdafd6324386a6")
				// {
				// 	//data.valid =true;
				// 	response.Reinvest.push({"UserReinvest":'0x' +item.topics[1].substring(26), "UserParentReinvest":'0x' +item.topics[2].substring(26)});
				// } 
				
				// if(item.topics[0] == "0xddf252ad1be2c89b69c2b068fc378daa952ba7f163c4a11628f55a4df523b3ef" && '0x' + item.topics[2].substring(26) != queryData.eventAddress.substring(0))
				// {
				// 	//data.valid =true;
				// 	response.Transfers.push({"From":'0x' +item.topics[1].substring(26), "To":'0x' +item.topics[2].substring(26), "value":web3.utils.hexToNumberString(item.data)});
						
				// } 
				// if(item.topics[0] == "0x68062c5925c4317adf3a7095478d28b33fd8b41458bc7620b61bc46bf1b24d82")
				// {
				// 	//data.valid =true;
				// 	response.Parents.push({"UserPlace":'0x' +item.topics[1].substring(26), "ParentPlace":'0x' +item.topics[2].substring(26),"Matrix":web3.utils.hexToNumber('0x'+item.data.substring(130))});						
				// } 
				
			});
			
			
			// var regLogs = _.filter(txnresult.logs, function (item) { return item.topics[0]=="0x309bb360e8b69c23937ccc5fb01f9aeeead1c95a99604e175113ff82f2b1723a"; }); 
			// if(regLogs.length >0){
			// 	response.UserAddress ='0x' + regLogs[0].topics[1].substring(26);
			// 	response.UserRegId = web3.utils.hexToNumber(regLogs[0].topics[3]);
			// }
				
			data.Transactions  = response;
			res.send(JSON.stringify(data));	
						
		})
		.catch(function(fallback) {
				res.type('application/json');
				data.status = "failed";
				data.message=JSON.parse(fallback.responseText).error;
				res.send(JSON.stringify(data));
		});
		
	 }
	 else 
	 {
			res.type('application/json');
			data.status = "succeed";
			data.Transactions="Invalid parameters";
			res.send(JSON.stringify(data));
	 } 
});

// function getTransaction(Trx)
// {
// 	var receipt = web3.eth.getTransactionReceipt(Trx)
// 		.then(function(result){
			
// 			return(JSON.stringify(result));			// same results as the optional callback above
// 		});;
	
// }

app.listen(PORT, () => {
 console.log('Server running on port %d', PORT);
 

 });

	
