// Import Web3
 // Use require for CommonJS
const { Web3 } = require('web3');
// Initialize Web3 with the RPC URL
const web3 = new Web3('https://rpc.fyrochain.com');

const miningAccount = "0xcbf934Aa89EAbcb5ee2F98874a8a493AFF338EB9";  // Replace with your mining account address

const checkAndMine = async () => {
    try {
      const pendingTransactions = await web3.eth.getPendingTransactions();
      const pendingTxCount = pendingTransactions.length;
  
      if (pendingTxCount > 0) {
        console.log(`${pendingTxCount} pending transaction(s) detected. Starting mining...`);
        
        // Start the miner if not already mining
        const isMining = await web3.eth.isMining();
        if (!isMining) {
          await web3.eth.personal.unlockAccount(miningAccount, "123456789", 600);  // Unlock your mining account
          
          // Set etherbase before starting mining
          web3.currentProvider.send({
            method: "miner_setEtherbase",
            params: [miningAccount],
            jsonrpc: "2.0",
            id: new Date().getTime()
          }, (error, result) => {
            if (error) {
              console.error('Error setting etherbase:', error);
            } else {
              console.log('Etherbase set successfully:', result);
              
              // Start mining
              web3.currentProvider.send({
                method: "miner_start",
                params: [],  // No parameters
                jsonrpc: "2.0",
                id: new Date().getTime()
              }, (error, result) => {
                if (error) {
                  console.error('Error starting miner:', error);
                } else {
                  console.log('Miner started successfully:', result);
                }
              });
            }
          });
        }
      } else {
        console.log("No pending transactions. Stopping mining...");
        
        const isMining = await web3.eth.isMining();
        if (isMining) {
          // Stop mining using RPC call
          await web3.currentProvider.send({
            method: "miner_stop",
            jsonrpc: "2.0",
            id: new Date().getTime()
          });
          console.log("Miner stopped.");
        }
      }
    } catch (error) {
      console.error("Error checking transactions or controlling miner:", error);
    }
  };
  
  setInterval(checkAndMine, 5000);
  

setInterval(checkAndMine, 5000);