const express = require('express');
const axios = require('axios');
const { Client } = require('pg');
//const Web3 = require('web3');
const { Web3 } = require('web3');
// Initialize Web3 with the RPC URL


const app = express();
const port = 8123;


const dbConfig = {
    user: 'ojpasoftware_NFT_user',
    host: '109.123.236.127',
    database: 'ojpasoftware_fyrochain',
    password: 'LoGiCmysql123',
    port: '5432',
  };
// Create a PostgreSQL client
const pool = new Client(dbConfig);

// Connect to PostgreSQL
pool.connect()
  .then(() => console.log('Connected to PostgreSQL'))
  .catch(err => console.error('Error connecting to PostgreSQL', err));

// RPC URL for your blockchain
const web3 = new Web3('https://rpc.fyrochain.com');


const handleLatestTransactions = async () => {
    //console.log("handleLatestTransactions");
    try {
        const latestBlockNumber = await web3.eth.getBlockNumber();
       // console.log("latestBlockNumber", latestBlockNumber.toString());

        let transactions = [];

        for (let i = Number(latestBlockNumber); i > Math.max(0, Number(latestBlockNumber) - 10); i--) {
            const block = await web3.eth.getBlock(i);

            //console.log("block number:", block.number.toString());  // Convert BigInt to string for logging

            const blockData = {
                number: block.number.toString(),
                difficulty: block.difficulty.toString(),
                gasLimit: block.gasLimit.toString(),
                gasUsed: block.gasUsed.toString(),
                timestamp: new Date(Number(block.timestamp) * 1000),  // Convert BigInt timestamp to Date
                miner: block.miner,
                hash: block.hash,
                transactions: block.transactions,
            };

           // console.log("Processed block data:", blockData);

            for (const txHash of block.transactions) {
                const tx = await web3.eth.getTransaction(txHash);
                const receipt = await web3.eth.getTransactionReceipt(txHash);
                const status = receipt ? receipt.status : 'Pending';

                const amount = (BigInt(tx.value) / BigInt(1e18)).toString();
                const gas = tx.gas.toString();
                const gasPrice = tx.gasPrice.toString();

                // if (tx.from !== '0x4F4EDD1d27dAe9e746c264b64D429DB410966651' &&
                //     tx.from !== '0xaA718cFe1B94910Ea030491397F69Aa2eebf0DA4' &&
                //     tx.from !== '0xa042CD5D4Ba25CA3F8657Ace554D646F711fd46F') {

                // console.log(`
                //         INSERT INTO tbl_transection 
                //         (hash, blockhash, blocknumber, from_address, gas, gasprice, input, nonce, to_address, transactionindex, value, type, chainid, v, r, s, transection_status)
                //         SELECT $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17
                //         WHERE NOT EXISTS (SELECT 1 FROM tbl_transection WHERE hash = $1)
                //     `);
                

                //     await pool.query(`
                //         INSERT INTO tbl_transection 
                //         (hash, blockhash, blocknumber, from_address, gas, gasprice, input, nonce, to_address, transactionindex, value, type, chainid, v, r, s, transection_status)
                //         SELECT $1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15, $16, $17
                //         WHERE NOT EXISTS (SELECT 1 FROM tbl_transection WHERE hash = $1)
                //     `, [
                //         txHash, tx.blockHash, block.number.toString(), tx.from, gas, gasPrice, tx.input, tx.nonce,
                //         tx.to, tx.transactionIndex, amount, tx.type, tx.chainId, tx.v, tx.r, tx.s, status
                //     ]);

                    

                    await pool.query(`INSERT INTO tbl_transection (hash, blockhash, blocknumber, from_address, gas, gasprice, input, nonce, to_address, transactionindex, value, type, chainid, v, r, s, transection_status) SELECT '${txHash}', '${tx.blockHash}', '${tx.blockNumber}', '${tx.from}', '${tx.gas}', '${tx.gasPrice}', '${tx.input}', '${tx.nonce}', '${tx.to}', '${tx.transactionIndex}', '${amount}', '${tx.type}', '${tx.chainId}', '${tx.v}', '${tx.r}', '${tx.s}', '${status}' WHERE NOT EXISTS ( SELECT 1 FROM tbl_transection WHERE hash = '${txHash}' );
                         UPDATE tbl_current_supply SET current_amount = current_amount + '${amount}'`);

                    // await pool.query(`
                    //     UPDATE tbl_current_supply 
                    //     SET current_amount = current_amount + $1::numeric
                    // `, [amount]);
               // }

                transactions.push(tx);
            }
        }

        //console.log('Latest transactions processed.');
    } catch (error) {
        console.error('Error fetching latest transactions:', error.message);
    }
};





// Call the handler initially
handleLatestTransactions();

// Call the handler every 5 seconds
setInterval(handleLatestTransactions, 5000);

app.listen(port, () => {
    console.log(`Server is running on port ${port}`);
});
